import React from 'react';
import {UnControlled as CodeMirror} from "react-codemirror2";
import {OpaLang} from "../Opa"

import 'codemirror/mode/diff/diff'

const DiffLang = (props: OpaLang) => {
    const data: any = props.data;
    const optionsDiff = {
        mode: 'diff',
        lineNumbers: true,
        tabSize: 2,
        lineWrapping: true,
        readOnly: data.readOnly ? data.readOnly : false,
        styleActiveLine: true,
        addModeClass: true
    };

    return (
        <CodeMirror
            className={data.class ? data.class : null}
            value={data.value ? data.value : null}
            options={optionsDiff}
        />
    )
};

export default DiffLang