import React, {useEffect, useState} from 'react';
import {UnControlled as CodeMirror} from "react-codemirror2";
import {OpaLang} from "../Opa"

import "codemirror/mode/javascript/javascript";
import '../linter/jsonlint'
import 'codemirror/addon/lint/lint'
import '../css/linter.css'


const JsonLang = (props: OpaLang) => {
    const [state, setState] = useState(props.data.value)
    const data = props.data

    useEffect(() => {
        data.getData && data.getData(state)
    }, [state])

    const optionsJson: any = {
        mode: {
            name: "javascript",
            json: true,
            statementIndent: 2
        },
        lineNumbers: true,
        lineWrapping: true,
        tabSize: 2,
        readOnly: data.readOnly ? data.readOnly : false,
        styleActiveLine: true,
        autoCloseBrackets: true,
        gutters: data.lint ? ['CodeMirror-lint-markers'] : [],
        lint: data.lint ? data.lint : false
    }

    return (
        <CodeMirror
            className={data.class && data.class}
            value={data.value && data.value}
            options={optionsJson}
            onChange={(editor, data, value) => {
                setState(value)
            }}
        />
    );
};

export default JsonLang;
