import React, { useEffect, useRef } from 'react';
import '../css/merge.css'

import {OpaLang} from '../Opa'
import DiffMatchPatch from 'diff-match-patch';

const CodeMirror = require('codemirror');

const MergeViewCodeMirror = require('../merge/merge');


const MergeLang = (props: OpaLang) => {
    const data: any = props.data;
    const refCode = useRef() as React.MutableRefObject<HTMLDivElement>;

    let mode: any

    if (data.modeMerge === 'json') {
        mode = {
            name: "javascript",
            json: true,
            statementIndent: 2
        }
    } else {
        mode = data.modeMerge
    }

    useEffect(() => {
        MergeViewCodeMirror.init(CodeMirror, DiffMatchPatch);
        CodeMirror.MergeView(refCode.current, {
            value: data.value,
            origLeft: null,
            origRight: data.origRight,
            lineNumbers: true,
            tabSize: 2,
            lineWrapping: true,
            readOnly: data.readOnly ? data.readOnly : false,
            collapseIdentical: true,
            revertButtons: false,
            styleActiveLine: true,
            highlightDifferences: true,
            mode: mode ? mode : null
        });
    }, [])

    return (
        <div ref={refCode} className={data.class ? data.class : null}>
        </div>
    )
};

export default MergeLang