import React, {useEffect, useState} from 'react';
import {UnControlled as CodeMirror} from "react-codemirror2";
import {OpaLang} from "../Opa"

import '../modes/regoMode'
import 'codemirror-rego/key-map'


const RegoLang = (props: OpaLang) => {
    const [state, setState] = useState(props.data.value)
    const data: any = props.data

    useEffect(() => {
        data.getData && data.getData(state)
    }, [state])

    const optionsRego = {
        mode: 'rego',
        keyMap: 'styra',
        lineNumbers: true,
        lineWrapping: true,
        tabSize: 2,
        readOnly: data.readOnly ? data.readOnly : false,
        styleActiveLine: true,
        addModeClass: true,
        autoCloseBrackets: true
    }

    return (
        <CodeMirror
            className={data.class ? data.class : null}
            value={data.value ? data.value : null}
            options={optionsRego}
            onChange={(editor, data, value) => {
                setState(value)
            }}
        />
    );
};

export default RegoLang;
